﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Drawing;
using Syncfusion.Pdf.Parsing;
using System.Reflection;

namespace GettingStarted
{
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();
		}

        void OnButtonClicked(object sender, EventArgs args)
        {
            //Load the file as stream
            Stream docStream = typeof(App).GetTypeInfo().Assembly.GetManifestResourceStream("GettingStarted.Input.pdf");

            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(docStream);

            //Create booklet with two sides
            PdfDocument document = PdfBookletCreator.CreateBooklet(loadedDocument, new SizeF(1000, 700), true);

            MemoryStream memoryStream = new MemoryStream();

            //Save the document into memory stream
            document.Save(memoryStream);

            //close the documents
            document.Close(true);

            loadedDocument.Close(true);          

            //Save the stream as a file in the device and invoke it for viewing
            Xamarin.Forms.DependencyService.Get<ISave>().SaveAndView("Output.pdf", "application/pdf", memoryStream);
        }

    }
}
